## frotz 2.40

=== Makefile ===
#Define your C compiler.  I recommend gcc if you have it.
CC = gcc
#CC = cc

# Define your optimization flags.  Most compilers understand -O and -O2,
# Standard (note: Solaris on UltraSparc using gcc 2.8.x might not like this.)
OPTS = -O2 
# Pentium with gcc 2.7.0 or better
#OPTS = -O2 -fomit-frame-pointer -malign-functions=2 -malign-loops=2 \
#-malign-jumps=2

# Define where you want Frotz to be installed.  Usually this is /usr/local
PREFIX = /usr/local
#PREFIX =

# Define where you want Frotz to look for frotz.conf.
CONFIG_DIR = /usr/local/etc
#CONFIG_DIR = /etc
#CONFIG_DIR = /usr/pkg/etc
#CONFIG_DIR =

# Uncomment this if you want color support.  Usually this requires ncurses.
#COLOR_DEFS = -DCOLOR_SUPPORT

# Uncomment this if you have an OSS soundcard driver and want classical
# Infocom sound support.
#SOUND_DEFS = -DOSS_SOUND

# This should point to the location of your curses.h or ncurses.h include
# file if your compiler doesn't know about it.
INCL = -I/usr/local/include
#INCL = -I/usr/pkg/include
#INCL = -I/usr/freeware/include
#INCL = -I/5usr/include
#INCL =

# This should define the location and name of whatever curses library you're
# linking with.  Usually, this isn't necessary if /etc/ld.so.conf is set
# up correctly.
LIB = -L/usr/local/lib
#LIB = -L/usr/pkg/lib
#LIB = -L/usr/freeware/lib
#LIB = -L/5usr/lib
#LIB =

# One of these must be uncommented, use ncurses if you have it. 
CURSES = -lncurses	# Linux always uses ncurses.
#CURSES = -lcurses

# Comment this out if you're not using ncurses.
CURSES_DEF = -DUSE_NCURSES_H

# Uncomment this if you're compiling Unix Frotz on a machine that lacks
# the memmove(3) system call.  If you don't know what this means, leave it
# alone.
#MEMMOVE_DEF = -DNO_MEMMOVE

# Uncomment this if for some wacky reason you want to compile Unix Frotz
# under Cygwin under Windoze.  This sort of thing is not reccomended.
#EXTENSION = .exe


#####################################################
# Nothing under this line should need to be changed.
#####################################################

VERSION = 2.40

BINNAME = frotz

DISTNAME = $(BINNAME)-$(VERSION)

OBJECTS = buffer.o err.o fastmem.o files.o hotkey.o input.o main.o \
	math.o object.o process.o quetzal.o random.o redirect.o \
	screen.o sound.o stream.o table.o text.o ux_init.o ux_input.o \
	ux_pic.o ux_screen.o ux_text.o variable.o \
	ux_audio_none.o ux_audio_oss.o

OPT_DEFS = -DCONFIG_DIR="\"$(CONFIG_DIR)\"" $(CURSES_DEF)

COMP_DEFS = $(OPT_DEFS) $(COLOR_DEFS) $(SOUND_DEFS) $(SOUNDCARD) \
	$(MEMMOVE_DEF)

CFLAGS = $(OPTS) $(COMP_DEFS) $(INCL)


$(BINNAME): soundcard.h $(OBJECTS)
	$(CC) -o $(BINNAME)$(EXTENSION) $(OBJECTS) $(LIB) $(CURSES)

soundcard.h:
	@if [ ! -f soundcard.h ] ; then ./findsound.sh; fi

install: $(BINNAME)
	strip $(BINNAME)
	install -c -m 755 $(BINNAME)$(EXTENSION) $(PREFIX)/bin
	install -c -m 644 $(BINNAME).6 $(PREFIX)/man/man6

uninstall:
	rm -f $(PREFIX)/bin/$(BINNAME)$(EXTENSION)
	rm -f $(PREFIX)/man/man6/$(BINNAME).6

deinstall: uninstall

clean:
	rm -f *.o

distro: dist

dist: distclean
	cd .. ; tar cfv $(DISTNAME).tar $(DISTNAME) ; gzip -f $(DISTNAME).tar

distclean: clean
	rm -f soundcard.h
	rm -f $(BINNAME)$(EXTENSION)

realclean: distclean

clobber: distclean

help:
	@echo
	@echo "Targets:"
	@echo "    frotz"
	@echo "    install"
	@echo "    uninstall"
	@echo "    clean"
	@echo "    distclean"
	@echo

## frotz 2.43

=== Makefile ===
# Define your C compiler.  I recommend gcc if you have it.
# MacOS users should use "cc" even though it's really "gcc".
#
CC = gcc
#CC = cc

# Define your optimization flags.  Most compilers understand -O and -O2,
# Standard (note: Solaris on UltraSparc using gcc 2.8.x might not like this.)
#
OPTS = -O2 

# Pentium with gcc 2.7.0 or better
#OPTS = -O2 -fomit-frame-pointer -malign-functions=2 -malign-loops=2 \
#-malign-jumps=2

# Define where you want Frotz installed.  Usually this is /usr/local
PREFIX = /usr/local

MAN_PREFIX = $(PREFIX)
#MAN_PREFIX = /usr/local/share

CONFIG_DIR = $(PREFIX)/etc
#CONFIG_DIR = /etc

# Define where you want Frotz to look for frotz.conf.
#
CONFIG_DIR = /usr/local/etc
#CONFIG_DIR = /etc
#CONFIG_DIR = /usr/pkg/etc
#CONFIG_DIR =

# Uncomment this if you want color support.  Most, but not all curses
# libraries that work with Frotz will support color.
#
COLOR_DEFS = -DCOLOR_SUPPORT

# Uncomment this if you have an OSS soundcard driver and want classical
# Infocom sound support.
#
#SOUND_DEFS = -DOSS_SOUND

# Uncomment this too if you're running BSD of some sort and are using
# the OSS sound driver.
#
#SOUND_LIB = -lossaudio

# Define your sound device 
# This should probably be a command-line/config-file option.
#
#SOUND_DEV = /dev/dsp
#SOUND_DEV = /dev/sound
#SOUND_DEV = /dev/audio

# If your vendor-supplied curses library won't work, uncomment the
# location where ncurses.h is.
#
#INCL = -I/usr/local/include
#INCL = -I/usr/pkg/include
#INCL = -I/usr/freeware/include
#INCL = -I/5usr/include
#INCL = -I/path/to/ncurses.h

# If your vendor-supplied curses library won't work, uncomment the
# location where the ncurses library is.
#
#LIB = -L/usr/local/lib
#LIB = -L/usr/pkg/lib
#LIB = -L/usr/freeware/lib
#LIB = -L/5usr/lib
#LIB = -L/path/to/libncurses.so

# One of these must always be uncommented.  If your vendor-supplied
# curses library won't work, comment out the first option and uncomment
# the second.
#
CURSES = -lcurses
#CURSES = -lncurses

# Uncomment this if your need to use ncurses instead of the
# vendor-supplied curses library.  This just tells the compile process
# which header to include, so don't worry if ncurses is all you have
# (like on Linux).  You'll be fine.
#
#CURSES_DEF = -DUSE_NCURSES_H

# Uncomment this if you're compiling Unix Frotz on a machine that lacks
# the memmove(3) system call.  If you don't know what this means, leave it
# alone.
#
#MEMMOVE_DEF = -DNO_MEMMOVE

# Uncomment this if for some wacky reason you want to compile Unix Frotz
# under Cygwin under Windoze.  This sort of thing is not reccomended.
#
#EXTENSION = .exe


#####################################################
# Nothing under this line should need to be changed.
#####################################################

SRCDIR = src

VERSION = 2.43
 
NAME = frotz
BINNAME = $(NAME)

DISTFILES = bugtest

DISTNAME = $(BINNAME)-$(VERSION)
distdir = $(DISTNAME)

COMMON_DIR = $(SRCDIR)/common
COMMON_TARGET = $(SRCDIR)/frotz_common.a
COMMON_OBJECT = $(COMMON_DIR)/buffer.o \
		$(COMMON_DIR)/err.o \
		$(COMMON_DIR)/fastmem.o \
		$(COMMON_DIR)/files.o \
		$(COMMON_DIR)/hotkey.o \
		$(COMMON_DIR)/input.o \
		$(COMMON_DIR)/main.o \
		$(COMMON_DIR)/math.o \
		$(COMMON_DIR)/object.o \
		$(COMMON_DIR)/process.o \
		$(COMMON_DIR)/quetzal.o \
		$(COMMON_DIR)/random.o \
		$(COMMON_DIR)/redirect.o \
		$(COMMON_DIR)/screen.o \
		$(COMMON_DIR)/sound.o \
		$(COMMON_DIR)/stream.o \
		$(COMMON_DIR)/table.o \
		$(COMMON_DIR)/text.o \
		$(COMMON_DIR)/variable.o

CURSES_DIR = $(SRCDIR)/curses
CURSES_TARGET = $(SRCDIR)/frotz_curses.a
CURSES_OBJECT = $(CURSES_DIR)/ux_init.o \
		$(CURSES_DIR)/ux_input.o \
		$(CURSES_DIR)/ux_pic.o \
		$(CURSES_DIR)/ux_screen.o \
		$(CURSES_DIR)/ux_text.o \
		$(CURSES_DIR)/ux_audio_none.o \
		$(CURSES_DIR)/ux_audio_oss.o

DUMB_DIR = $(SRCDIR)/dumb
DUMB_TARGET = $(SRCDIR)/frotz_dumb.a
DUMB_OBJECT =	$(DUMB_DIR)/dumb_init.o \
		$(DUMB_DIR)/dumb_input.o \
		$(DUMB_DIR)/dumb_output.o \
		$(DUMB_DIR)/dumb_pic.o

TARGETS = $(COMMON_TARGET) $(CURSES_TARGET)

OPT_DEFS = -DCONFIG_DIR="\"$(CONFIG_DIR)\"" $(CURSES_DEF) \
	-DVERSION="\"$(VERSION)\"" -DSOUND_DEV="\"$(SOUND_DEV)\""

COMP_DEFS = $(OPT_DEFS) $(COLOR_DEFS) $(SOUND_DEFS) $(SOUNDCARD) \
	$(MEMMOVE_DEF)

FLAGS = $(OPTS) $(COMP_DEFS) $(INCL)

$(NAME): $(NAME)-curses

$(NAME)-curses:		soundcard.h  $(COMMON_TARGET) $(CURSES_TARGET)
	$(CC) -o $(BINNAME)$(EXTENSION) $(TARGETS) $(LIB) $(CURSES) \
		$(SOUND_LIB)

all:	$(NAME) d$(NAME)

dumb:		$(NAME)-dumb
d$(NAME):	$(NAME)-dumb
$(NAME)-dumb:		$(COMMON_TARGET) $(DUMB_TARGET)
	$(CC) -o d$(BINNAME)$(EXTENSION) $(COMMON_TARGET) \
		$(DUMB_TARGET) $(LIB)

.SUFFIXES:
.SUFFIXES: .c .o .h

.c.o:
	$(CC) $(FLAGS) $(CFLAGS) -o $@ -c $<

# If you're going to make this target manually, you'd better know which 
# config target to make first.
#
common_lib:	$(COMMON_TARGET)
$(COMMON_TARGET): $(COMMON_OBJECT)
	@echo
	@echo "Archiving common code..."
	ar rc $(COMMON_TARGET) $(COMMON_OBJECT)
	ranlib $(COMMON_TARGET)
	@echo

curses_lib:	config_curses $(CURSES_TARGET)
$(CURSES_TARGET): $(CURSES_OBJECT)
	@echo
	@echo "Archiving curses interface code..."
	ar rc $(CURSES_TARGET) $(CURSES_OBJECT)
	ranlib $(CURSES_TARGET)
	@echo

dumb_lib:	$(DUMB_TARGET)
$(DUMB_TARGET): $(DUMB_OBJECT)
	@echo
	@echo "Archiving dumb interface code..."
	ar rc $(DUMB_TARGET) $(DUMB_OBJECT)
	ranlib $(DUMB_TARGET)
	@echo

soundcard.h:
	@if [ ! -f $(SRCDIR)/soundcard.h ] ; then \
		 sh $(SRCDIR)/misc/findsound.sh $(SRCDIR); \
	fi

install: $(NAME)
	strip $(BINNAME)$(EXTENSION)
	install -d $(PREFIX)/bin
	install -d $(MAN_PREFIX)/man/man6
	install -c -m 755 $(BINNAME)$(EXTENSION) $(PREFIX)/bin
	install -c -m 644 doc/$(NAME).6 $(MAN_PREFIX)/man/man6

uninstall:
	rm -f $(PREFIX)/bin/$(NAME)
	rm -f $(MAN_PREFIX)/man/man6/$(NAME).6

deinstall: uninstall

install_dumb: d$(NAME)
	strip d$(BINNAME)$(EXTENSION)
	install -d $(PREFIX)/bin
	install -d $(MAN_PREFIX)/man/man6
	install -c -m 755 d$(BINNAME)$(EXTENSION) $(PREFIX)/bin
	install -c -m 644 doc/d$(NAME).6 $(MAN_PREFIX)/man/man6

uninstall_dumb:
	rm -f $(PREFIX)/bin/d$(NAME)
	rm -f $(MAN_PREFIX)/man/man6/d$(NAME).6

deinstall_dumb: uninstall_dumb

distro: dist

dist: distclean
	mkdir $(distdir)
	@for file in `ls`; do \
		if test $$file != $(distdir); then \
			cp -Rp $$file $(distdir)/$$file; \
		fi; \
	done
	find $(distdir) -type l -exec rm -f {} \;
	tar chof $(distdir).tar $(distdir)
	gzip -f --best $(distdir).tar
	rm -rf $(distdir)
	@echo
	@echo "$(distdir).tar.gz created"
	@echo

clean:
	rm -f $(SRCDIR)/*.h $(SRCDIR)/*.a
	rm -f $(COMMON_DIR)/*.o $(CURSES_DIR)/*.o $(DUMB_DIR)/*.o

distclean: clean
	rm -f $(BINNAME)$(EXTENSION) d$(BINNAME)$(EXTENSION)
	rm -f *core $(SRCDIR)/*core
	-rm -rf $(distdir)
	-rm -f $(distdir).tar $(distdir).tar.gz
	
realclean: distclean

clobber: distclean

help:
	@echo
	@echo "Targets:"
	@echo "    frotz"
	@echo "    dfrotz"
	@echo "    install"
	@echo "    uninstall"
	@echo "    clean"
	@echo "    distclean"
	@echo

=== debian/changelog ===
frotz (2.43-4) unstable; urgency=low

  * Update upstream homepage (closes: #650257)
  * Converted to quilt source format and new policy

 -- Robert Lemmen <robertle@semistable.com>  Mon, 11 Jun 2012 10:07:24 +0100

frotz (2.43-3) unstable; urgency=low

  * Updated debhelper, standards-version and watch file

 -- Robert Lemmen <robertle@semistable.com>  Thu, 12 Mar 2009 19:31:39 +0000

frotz (2.43-2) unstable; urgency=low

  * Taking over package (closes: #483582)
  * Changed watch file to use current homepage (closes: #449905) 
  * Added homepage field to control file
  * Removed suggests and references to int-fiction-installer (closes: #461594)
  * Fixed and cleaned up debian/rules
  * Support nostrip build option (closes: #436874)
  * Included actual copyright statement in debian/copyright
  * Bumped standards-version

 -- Robert Lemmen <robertle@semistable.com>  Mon, 16 Jun 2008 20:22:30 +0100

frotz (2.43-1) unstable; urgency=low

  * New upstream release. (closes: #184758) 
  * New release fixes the ctrl-space bug. (closes: #90854)
  * Adopted. (closes: #201407)
  * Updated links to if-archive. (closes: #115809)
  * Repackaged using debhelper
  * Set default zcode_path in system-wide config file
  * Suggest int-fiction-installer

 -- Hans Fugal <hans@fugal.net>  Wed, 16 Jul 2003 07:28:17 -0600

frotz (2.40-3) unstable; urgency=low

  * Don't compile in sound support on the Hurd.  Closes: bug 99790.

 -- Charles Briscoe-Smith <cpbs@debian.org>  Mon,  4 Jun 2001 15:18:32 +0100

frotz (2.40-2) unstable; urgency=low

  * Rebuild against libncurses5.  Closes:bug#92509.
  * Work around dpkg-shlibdeps bug by running dpkg-shlibdeps as root.
    Closes:Bug#90699.
  * Edit down the upstream INSTALL file and install it in
    /usr/share/doc/frotz as "INSTALLING.GAMES".

 -- Charles Briscoe-Smith <cpbs@debian.org>  Wed,  9 May 2001 12:29:36 +0100

frotz (2.40-1) unstable; urgency=low

  * New upstream release.  (Closes:Bug#77358).
  * Moved to "main"; Frotz is now GPLed!
  * Ported old Debian patches to the new release.
  * Default name for saved games now has ".frotz" if Frotz's old save
    format is in use (-Q on command line) or ".sav" if Quetzal is being
    used (the default).
  * Updated to policy version 3.2.1.
  * Removed conflicts against ancient versions of some zcode games.
  * Bumped up frotz's alternatives priority a bit, so that it's definitely
    preferred over jzip.  This should be okay now that frotz is free.
    (Closes:Bug#53430).
  * Comply with the FHS.
  * Built against libncurses5.  (Closes:Bug#69700).

 -- Charles Briscoe-Smith <cpbs@debian.org>  Tue,  2 Jan 2001 17:22:28 +0000

frotz (2.32r2-12) frozen unstable; urgency=low

  * Recompile to fix dependencies.  Now depends on libc6, with no
    version requirement.

 -- Charles Briscoe-Smith <cpbs@debian.org>  Fri, 11 Dec 1998 19:20:52 +0000

frotz (2.32r2-11) frozen unstable; urgency=low

  * Recompile against libncurses4.

 -- Charles Briscoe-Smith <cpbs@debian.org>  Fri,  6 Nov 1998 03:13:06 +0000

frotz (2.32r2-10) frozen unstable; urgency=low

  * By default, saved games now go into ~/.infocom with extension
    ".frotz".  (Fixes:bug#21054)

 -- Charles Briscoe-Smith <cpbs@debian.org>  Wed, 13 May 1998 21:44:52 +0100

frotz (2.32r2-9) frozen unstable; urgency=low

  * Move /usr/bin/zcode-interpreter to /usr/games.
  * Add some jiggery-pokery to maintainer scripts to clean up the mess
    the zcode-interpreter alternatives were in.

 -- Charles Briscoe-Smith <cpbs@debian.org>  Tue,  7 Apr 1998 22:26:06 +0100

frotz (2.32r2-8) frozen unstable; urgency=low

  * Doh!  I'd moved the binary from /usr/bin to /usr/games, but didn't
    update the alternatives to match.  Fixed.

 -- Charles Briscoe-Smith <cpbs@debian.org>  Mon,  6 Apr 1998 22:44:15 +0100

frotz (2.32r2-7) frozen unstable; urgency=low

  * Moved frotz from /usr/bin to /usr/games.  (Fixes:bug#19730)
    Technically, frotz is a virtual machine interpreter, not a game,
    but most people are likely to look for it in /usr/games first.

 -- Charles Briscoe-Smith <cpbs@debian.org>  Sat, 28 Mar 1998 11:48:46 +0000

frotz (2.32r2-6) unstable; urgency=low

  * Remove dpkg-geninfo from debian directory and remove call to it
    from debian/rules following debian-policy discussion on `md5sums'
    and `du' files.
  * Stripped /usr/bin/frotz.

 -- Charles Briscoe-Smith <cpbs@debian.org>  Thu, 12 Mar 1998 01:56:53 +0000

frotz (2.32r2-5) unstable; urgency=low

  * Removed conflict against the (as yet) nonexistant "tatctae".

 -- Charles Briscoe-Smith <cpbs@debian.org>  Thu, 12 Feb 1998 22:58:06 +0000

frotz (2.32r2-4) unstable; urgency=low

  * Updated due to obsoletion of the `zcode-support' package.
    Use update-alternatives method instead.
  * Conflict and replace zcode-support.
  * Actually install the man page.  (Oops.)

  * Updated to standards-version 2.4.0.0.  No changes necessary.
  * Use new maintainer email address <cpbs@debian.org>.
  * New version of generic debian/rules, together with dpkg-geninfo.
    New debian/process based on old debian/rules.

 -- Charles Briscoe-Smith <cpbs@debian.org>  Sun,  8 Feb 1998 21:41:57 +0000

frotz (2.32r2-3) unstable; urgency=low

  * Updated for libc6.  (Actually, nothing in the source changed; this
    is just a recompile.)

 -- Charles Briscoe-Smith <cpb4@ukc.ac.uk>  Tue, 11 Nov 1997 02:47:22 +0000

frotz (2.32r2-2) unstable; urgency=low

  * Increased TEXT_BUFFER_SIZE in frotz.h from 200 to 500; some zcode
    files overflowed the smaller buffer.

 -- Charles Briscoe-Smith <cpb4@ukc.ac.uk>  Sun, 26 Oct 1997 19:41:47 +0000

frotz (2.32r2-1) unstable; urgency=low

  * New upstream source.
  * Added clean target in Makefile, which seems to have dropped out of
    the upstream sources.
  * No longer change INFOCOM_PATH to ZCODE_PATH.

 -- Charles Briscoe-Smith <cpb4@ukc.ac.uk>  Mon, 20 Oct 1997 21:49:57 +0100

frotz (2.01-2) unstable; urgency=low

  * Corrected typo of standards-version in debian/control.


=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_install:
	$(MAKE) PREFIX=$$(pwd)/debian/frotz/usr install

## frotz 2.44

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # Define your optimization flags.  Most compilers understand -O and -O2,
 # Standard (note: Solaris on UltraSparc using gcc 2.8.x might not like this.)
 #
-OPTS = -O2 
+OPTS = -O2
 
 # Pentium with gcc 2.7.0 or better
 #OPTS = -O2 -fomit-frame-pointer -malign-functions=2 -malign-loops=2 \
@@ -44,7 +44,7 @@
 #
 #SOUND_LIB = -lossaudio
 
-# Define your sound device 
+# Define your sound device
 # This should probably be a command-line/config-file option.
 #
 #SOUND_DEV = /dev/dsp
@@ -94,6 +94,12 @@
 #
 #EXTENSION = .exe
 
+SDLINC = `sdl-config --cflags`
+FTCFLAGS = `freetype-config --cflags`
+FTLIBS = `freetype-config --libs`
+
+SDL_DEFS = $(SDLINC) $(FTCFLAGS) $(FTLIBS)
+SDL_LIBS = -ljpeg -lpng -lz -lSDL -lSDL_mixer
 
 #####################################################
 # Nothing under this line should need to be changed.
@@ -101,8 +107,8 @@
 
 SRCDIR = src
 
-VERSION = 2.43
- 
+VERSION = 2.44
+
 NAME = frotz
 BINNAME = $(NAME)
 
@@ -140,6 +146,7 @@
 		$(CURSES_DIR)/ux_pic.o \
 		$(CURSES_DIR)/ux_screen.o \
 		$(CURSES_DIR)/ux_text.o \
+		$(CURSES_DIR)/ux_blorb.o \
 		$(CURSES_DIR)/ux_audio_none.o \
 		$(CURSES_DIR)/ux_audio_oss.o
 
@@ -150,37 +157,79 @@
 		$(DUMB_DIR)/dumb_output.o \
 		$(DUMB_DIR)/dumb_pic.o
 
-TARGETS = $(COMMON_TARGET) $(CURSES_TARGET)
+SDL_DIR = $(SRCDIR)/sdl
+SDL_TARGET = $(SRCDIR)/frotz_sdl.a
+SDL_OBJECT =	$(SDL_DIR)/sf_aiffwav.o \
+		$(SDL_DIR)/sf_deffont.o \
+		$(SDL_DIR)/sf_font3.o \
+		$(SDL_DIR)/sf_fonts.o \
+		$(SDL_DIR)/sf_ftype.o \
+		$(SDL_DIR)/sf_images.o \
+		$(SDL_DIR)/sf_msg_en.o \
+		$(SDL_DIR)/sf_osfdlg.o \
+		$(SDL_DIR)/sf_resample.o \
+		$(SDL_DIR)/sf_resource.o \
+		$(SDL_DIR)/sf_sig.o \
+		$(SDL_DIR)/sf_sound.o \
+		$(SDL_DIR)/sf_util.o \
+		$(SDL_DIR)/sf_video.o
+
+# Blorb file handling
+#
+BLORB_DIR = $(SRCDIR)/blorb
+BLORB_TARGET =  $(SRCDIR)/blorblib.a
+BLORB_OBJECT =  $(BLORB_DIR)/blorblib.o
+
+
+TARGETS = $(COMMON_TARGET) $(CURSES_TARGET) $(BLORB_TARGET)
 
 OPT_DEFS = -DCONFIG_DIR="\"$(CONFIG_DIR)\"" $(CURSES_DEF) \
-	-DVERSION="\"$(VERSION)\"" -DSOUND_DEV="\"$(SOUND_DEV)\""
-
-COMP_DEFS = $(OPT_DEFS) $(COLOR_DEFS) $(SOUND_DEFS) $(SOUNDCARD) \
+	-DVERSION="\"$(VERSION)\""
+
+CURSES_DEFS = $(OPT_DEFS) $(COLOR_DEFS) $(SOUND_DEFS) $(SOUNDCARD) \
 	$(MEMMOVE_DEF)
 
-FLAGS = $(OPTS) $(COMP_DEFS) $(INCL)
+FLAGS = $(OPTS) $(CURSES_DEFS) $(INCL)
+
 
 $(NAME): $(NAME)-curses
-
-$(NAME)-curses:		soundcard.h  $(COMMON_TARGET) $(CURSES_TARGET)
-	$(CC) -o $(BINNAME)$(EXTENSION) $(TARGETS) $(LIB) $(CURSES) \
-		$(SOUND_LIB)
-
-all:	$(NAME) d$(NAME)
+curses:  $(NAME)-curses
+$(NAME)-curses: $(COMMON_TARGET) $(CURSES_TARGET) $(BLORB_TARGET)
+	$(CC) -o $(BINNAME)$(EXTENSION) $(TARGETS) $(LIB) $(CURSES) $(SOUND_LIB)
 
 dumb:		$(NAME)-dumb
 d$(NAME):	$(NAME)-dumb
 $(NAME)-dumb:		$(COMMON_TARGET) $(DUMB_TARGET)
-	$(CC) -o d$(BINNAME)$(EXTENSION) $(COMMON_TARGET) \
-		$(DUMB_TARGET) $(LIB)
+	$(CC) -o d$(BINNAME)$(EXTENSION) $(COMMON_TARGET) $(DUMB_TARGET) $(LIB)
+
+sdl:		$(NAME)-sdl
+s$(NAME):	$(NAME)-sdl
+$(NAME)-sdl:	$(COMMON_TARGET) $(SDL_TARGET) $(BLORB_TARGET)
+	$(CC) -o s$(BINNAME) $(COMMON_TARGET) $(SDL_TARGET) $(BLORB_TARGET) $(SDL_LIBS)
+
+all:	$(NAME) d$(NAME)
+
 
 .SUFFIXES:
 .SUFFIXES: .c .o .h
 
-.c.o:
-	$(CC) $(FLAGS) $(CFLAGS) -o $@ -c $<
-
-# If you're going to make this target manually, you'd better know which 
+$(COMMON_OBJECT): %.o: %.c
+	$(CC) $(OPTS) $(COMMON_DEFS) -o $@ -c $<
+
+$(BLORB_OBJECT): %.o: %.c
+	$(CC) $(OPTS) -o $@ -c $<
+
+$(DUMB_OBJECT): %.o: %.c
+	$(CC) $(OPTS) -o $@ -c $<
+
+$(CURSES_OBJECT): %.o: %.c
+	$(CC) $(OPTS) $(CURSES_DEFS) -o $@ -c $<
+
+$(SDL_OBJECT): %.o: %.c
+	$(CC) $(OPTS) $(SDL_DEFS) -o $@ -c $<
+
+
+# If you're going to make this target manually, you'd better know which
 # config target to make first.
 #
 common_lib:	$(COMMON_TARGET)
@@ -206,6 +255,23 @@
 	ar rc $(DUMB_TARGET) $(DUMB_OBJECT)
 	ranlib $(DUMB_TARGET)
 	@echo
+
+sdl_lib:	$(SDL_TARGET)
+$(SDL_TARGET): $(SDL_OBJECT)
+	@echo
+	@echo "Archiving SDL interface code..."
+	ar rc $(SDL_TARGET) $(SDL_OBJECT)
+	ranlib $(SDL_TARGET)
+	@echo
+
+blorb_lib:	$(BLORB_TARGET)
+$(BLORB_TARGET): $(BLORB_OBJECT)
+	@echo
+	@echo "Archiving Blorb file handling code..."
+	ar rc $(BLORB_TARGET) $(BLORB_OBJECT)
+	ranlib $(BLORB_TARGET)
+	@echo
+
 
 soundcard.h:
 	@if [ ! -f $(SRCDIR)/soundcard.h ] ; then \
@@ -257,14 +323,17 @@
 
 clean:
 	rm -f $(SRCDIR)/*.h $(SRCDIR)/*.a
-	rm -f $(COMMON_DIR)/*.o $(CURSES_DIR)/*.o $(DUMB_DIR)/*.o
+	find . -name *.o -exec rm -f {} \;
+	find . -name *.O -exec rm -f {} \;
 
 distclean: clean
-	rm -f $(BINNAME)$(EXTENSION) d$(BINNAME)$(EXTENSION)
+	rm -f $(BINNAME)$(EXTENSION) d$(BINNAME)$(EXTENSION) s$(BINNAME)
+	rm -f *.EXE *.BAK *.LIB
+	rm -f *.exe *.bak *.lib
 	rm -f *core $(SRCDIR)/*core
 	-rm -rf $(distdir)
 	-rm -f $(distdir).tar $(distdir).tar.gz
-	
+
 realclean: distclean
 
 clobber: distclean

=== src/test/etude/Makefile ===

etude.z5: etude.inf header.inc styles.inc color.inc \
		accents.inc accentin.inc division.inc timedch.inc \
		timedstr.inc givenin.inc undo.inc exittext.inc
	inform etude.inf etude.z5

gntests.z5: gntests.inf
	inform gntests.inf gntests.z5

go: etude.z5
	xzip etude.z5

fgo: etude.z5
	frotz etude.z5

jgo: etude.z5
	jzip etude.z5

=== debian/changelog ===
frotz (2.44-1) unstable; urgency=medium

  * Maintenance release
    * Bumped standards-version and debhelper

 -- Robert Lemmen <robertle@semistable.com>  Thu, 15 Mar 2018 21:00:18 +0100

frotz (2.44-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release (closes: #786961).
  * Provide a zcode-interpreter alternative (closes: #780523).

 -- Stephen Kitt <skitt@debian.org>  Sun, 24 Jan 2016 15:28:52 +0100

=== debian/control ===
Source: frotz
Section: games
Priority: optional
Maintainer: Robert Lemmen <robertle@semistable.com>
Homepage: http://frotz.sourceforge.net/
Build-Depends: debhelper (>= 10), libncurses5-dev
Standards-Version: 4.1.3

Package: frotz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: zcode-interpreter
Conflicts: zcode-support
Replaces: zcode-support
Description: interpreter of Z-code story-files
 Frotz interprets Z-code story-files, which are usually text adventure
 games (although a few arcade-style Z-code games have been written).
 Examples of such story files include the adventure games published by
 Infocom, as well as any games produced by compilers to this format,
 such as Inform.  You can find a number of Inform-compiled games up for
 anonymous FTP at ftp://ftp.ifarchive.org/ or HTTP at http://www.ifarchive.org/
 .
 Frotz complies with the Z Machine specification version 1.0.

=== debian/watch ===
version=2
#http://www.cs.csubak.edu/~dgriffi/proj/frotz/ files/frotz-(.*)\.tar\.gz
#http://frotz.homeunix.org/frotz/ files/frotz-(.*)\.tar\.gz
http://sf.net/frotz/frotz-(.*)\.tar\.gz

## frotz 2.52+dfsg

=== debian/changelog ===
frotz (2.52+dfsg-2) unstable; urgency=medium

  * Source-only upload after going through NEW.

 -- Stephen Kitt <skitt@debian.org>  Tue, 04 Aug 2020 08:49:40 +0200

frotz (2.52+dfsg-1) unstable; urgency=medium

  * Adopt the package; thanks to Robert for maintaining the package all
    these years!
  * Switch to debhelper compatibility level 13.
  * Drop unnecessary buildtools.mk inclusion.
  * Wrap and sort the control files.
  * Set “Rules-Requires-Root: no”.
  * Enable all hardening options.
  * Re-write debian/copyright in machine-readable format. Some of the
    tests aren’t explicitly licensed, so exclude them for now to keep
    things simple.
  * Install the dumb and SDL versions; the SDL version is in a new
    package, sdlfrotz.
  * Fix some spelling mistakes spotted by Lintian.
  * Standards-Version 4.5.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 26 Jul 2020 21:37:05 +0200

frotz (2.52-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update debian/watch to track the GitLab repository (closes: #901364),
    and update the homepage.
  * Upgrade to 2.52, which builds with GCC 10 (closes: #957235),
    cross-builds correctly (closes: #884723), and includes UTF-8 and audio
    support (closes: #513736).

 -- Stephen Kitt <skitt@debian.org>  Thu, 23 Jul 2020 14:28:04 +0200

=== debian/control ===
Source: frotz
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Stephen Kitt <skitt@debian.org>
Homepage: https://davidgriffith.gitlab.io/frotz/
Build-Depends:
 debhelper-compat (= 13),
 libao-dev,
 libfreetype6-dev,
 libjpeg-dev,
 libmodplug-dev,
 libncurses5-dev,
 libpng-dev,
 libsamplerate0-dev,
 libsdl2-dev,
 libsdl2-mixer-dev,
 libsndfile1-dev,
 libvorbis-dev,
 zlib1g-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/games-team/frotz
Vcs-Git: https://salsa.debian.org/games-team/frotz.git
Rules-Requires-Root: no

Package: frotz
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 zcode-interpreter
Conflicts:
 zcode-support
Replaces:
 zcode-support
Description: interpreter of Z-code story-files
 Frotz interprets Z-code story-files, which are usually text adventure
 games (although a few arcade-style Z-code games have been written).
 Examples of such story files include the adventure games published by
 Infocom, as well as any games produced by compilers to this format,
 such as Inform.  You can find a number of Inform-compiled games up for
 anonymous FTP at ftp://ftp.ifarchive.org/ or HTTP at http://www.ifarchive.org/
 .
 Frotz complies with the Z Machine specification version 1.0.
 .
 This package contains the dumb and Curses versions of Frotz.

Package: sdlfrotz
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 zcode-interpreter
Conflicts:
 zcode-support
Replaces:
 zcode-support
Description: interpreter of Z-code story-files (SDL version)
 Frotz interprets Z-code story-files, which are usually text adventure
 games (although a few arcade-style Z-code games have been written).
 Examples of such story files include the adventure games published by
 Infocom, as well as any games produced by compilers to this format,
 such as Inform.  You can find a number of Inform-compiled games up for
 anonymous FTP at ftp://ftp.ifarchive.org/ or HTTP at http://www.ifarchive.org/
 .
 Frotz complies with the Z Machine specification version 1.0.
 .
 This package contains the SDL version of Frotz, which adds support
 for graphical Z6 games.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- CFLAGS="$(CPPFLAGS) $(CFLAGS)" all

override_dh_auto_install:
	$(MAKE) PREFIX=$$(pwd)/debian/tmp/usr install_all

## frotz 2.53+dfsg

=== Makefile ===
# Makefile for Unix Frotz
# GNU make is required.

# Your C compiler
#CC ?= gcc
#CC ?= clang

# Enable compiler warnings. This is an absolute minimum.
CFLAGS += -Wall -std=c99 -O3 #-Wextra

# Define your optimization flags.
#
# These are good for regular use.
#CFLAGS += -O2 -fomit-frame-pointer -falign-functions=2 -falign-loops=2 -falign-jumps=2
# These are handy for debugging.
CFLAGS += -g

# Define where you want Frotz installed
PREFIX ?= /usr/local
MANDIR ?= $(MAN_PREFIX)/man
BINDIR ?= $(PREFIX)/bin
#BINDIR ?= $(PREFIX)/games
MAN_PREFIX ?= $(PREFIX)/share
SYSCONFDIR ?= /etc

# Choose your sound support
# OPTIONS: ao, none
SOUND_TYPE ?= ao


##########################################################################
# The configuration options below are intended mainly for older flavors
# of Unix.  For Linux, BSD, and Solaris released since 2003, you can
# ignore this section.
##########################################################################

# Default sample rate for sound effects.
# All modern sound interfaces can be expected to support 44100 Hz sample
# rates.  Earlier ones, particularly ones in Sun 4c workstations support
# only up to 8000 Hz.
SAMPLERATE ?= 44100

# Audio buffer size in frames
BUFFSIZE ?= 4096

# Default sample rate converter type
DEFAULT_CONVERTER ?= SRC_SINC_MEDIUM_QUALITY

# Comment this out if you don't want UTF-8 support
USE_UTF8 ?= yes

# Comment this out if your machine's version of curses doesn't support color.
COLOR ?= yes

# Comment this out if your machine's version of curses doesn't support italic.
ITALIC ?= yes

# Select your chosen version of curses.  Unless something old is going
# on, ncursesw should be used because that's how UTF8 is supported.
#CURSES ?= curses
#CURSES ?= ncurses
CURSES ?= ncursesw

# This Makefile uses the pkg-config utility to get information on
# installed libraries.  If your system is missing that utility and
# cannot install it for whatever reason (usually very old ones), you
# will need to uncomment and perhaps modify some of these lines.
# I don't see any way around not having pkg-config for SDL.
#CURSES_LDLAGS += -l$(CURSES) -ltinfo
#CURSES_CFLAGS += -D_DEFAULT_SOURCE -D_XOPEN_SOURCE=600

# Uncomment this to disable Blorb support for dumb and curses interfaces.
# SDL interface always has Blorb support.
#NO_BLORB = yes

# These are for enabling local version of certain functions which may be
# missing or behave differently from what's expected in modern system.
# If you're running on a system made in the past 20 years, you should be
# safe leaving these alone.  If not or you're using something modern,
# but very strange intended for very limited machines, you probably know
# what you're doing.  Therefore further commentary on what these
# functions do is probably not necessary.

# For missing memmove()
#NO_MEMMOVE = yes

# For missing strdup() and strndup()
#NO_STRDUP = yes

# For missing strrchr()
#NO_STRRCHR = yes

# Uncomment to disable format codes for dumb interface
#DISABLE_FORMATS = yes

# Assorted constants
MAX_UNDO_SLOTS = 500
MAX_FILE_NAME = 80
TEXT_BUFFER_SIZE = 512
INPUT_BUFFER_SIZE = 200
STACK_SIZE = 1024


#########################################################################
# This section is where Frotz is actually built.
# Under normal circumstances, nothing in this section should be changed.
#########################################################################

# Windows - don't build
ifeq ($(OS),Windows_NT)
$(error Compilation on Windows not supported)
endif

# Determine what system we are on.
RANLIB ?= $(shell which ranlib)
AR ?= $(shell which ar)
# For now, assume !windows == unix.
OS_TYPE ?= unix
UNAME_S := $(shell uname -s)
PKG_CONFIG ?= pkg-config

# If we have pkg-config...
ifneq ($(shell which $(PKG_CONFIG)),)
# if pkg-config has $(CURSES)
ifeq ($(shell $(PKG_CONFIG) --exists $(CURSES) && echo 0),0)
# use pkg-config $(CURSES) info
PKG_CONFIG_CURSES = yes
CURSES_LDFLAGS += $(shell $(PKG_CONFIG) $(CURSES) --libs)
CURSES_CFLAGS += $(shell $(PKG_CONFIG) $(CURSES) --cflags)
else # Otherwise, try something obvious like before.
CURSES_LDFLAGS += -l$(CURSES)
endif
endif


# OS-specific configurations.
# NetBSD
ifeq ($(UNAME_S),NetBSD)
NETBSD = yes
CFLAGS += -D_NETBSD_SOURCE -I/usr/pkg/include
LDFLAGS += -Wl,-R/usr/pkg/lib -L/usr/pkg/lib
SDL_LDFLAGS += -lexecinfo
ifeq ($(CURSES), ncursesw)
CURSES_CFLAGS += -I/usr/pkg/include/ncursesw
else
CURSES_CFLAGS += -I/usr/pkg/include/ncurses
endif
endif

# FreeBSD
ifeq ($(UNAME_S),FreeBSD)
FREEBSD = yes
CFLAGS += -I/usr/local/include -D__BSD_VISIBLE=1
LDFLAGS += -L/usr/local/lib
SDL_LDFLAGS += -lexecinfo
endif

# OpenBSD
ifeq ($(UNAME_S),OpenBSD)
OPENBSD = yes
NO_EXECINFO_H = yes
NO_UCONTEXT_H = yes
NO_IMMINTRIN_H = yes
CFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
SDL_CFLAGS += -DSDL_DISABLE_IMMINTRIN_H
SDL_LDFLAGS += -lexecinfo
endif

# Linux
ifeq ($(UNAME_S),Linux)
LINUX = yes
CFLAGS += -D_POSIX_C_SOURCE=200809L
NPROCS = $(shell grep -c ^processor /proc/cpuinfo)
endif

# macOS
ifeq ($(UNAME_S),Darwin)
MACOS = yes
# On macOS, curses is actually ncurses, but to get wide
# char support you need to define _XOPEN_SOURCE_EXTENDED
# Often ncursesw is not present, but has wide support anyhow.
# Reset CURSES, use CURSES_MACOS on command line to override.
CURSES_MACOS ?= ncurses
CURSES = $(CURSES_MACOS)
# get flags from pkg-config curses if available
ifndef PKG_CONFIG_CURSES
# macOS provided ncurses, but doesn't have pkg-config .pc files installed.
# Since ncursesx.x-config (should be) available if curses is installed,
# use that instead of pkg-config to get --libs and --cflags.
# Search $PATH for ncursesx.x-config, use the first one.
CURSES_CONFIG ?= $(shell echo $$PATH | while read -d ':' p; do \
	stat -f'%N' $$p/$(CURSES)[0-9]*-config 2>/dev/null; done | head -n1)
# Reset CURSES_LDFLAGS, CURSES_CFLAGS.
CURSES_LDFLAGS = $(shell $(CURSES_CONFIG) --libs)
CURSES_CFLAGS = $(shell $(CURSES_CONFIG) --cflags)
ifeq ($(CURSES_CONFIG),)
$(error no $(CURSES)x.x-config found)
endif
endif
SDL_CFLAGS += -D_XOPEN_SOURCE
endif


# Make sure the right curses include file is included.
ifeq ($(CURSES), curses)
CURSES_DEFINE = USE_CURSES_H
else ifneq ($(findstring ncurses,$(CURSES)),)
CURSES_CFLAGS += -D_XOPEN_SOURCE_EXTENDED
CURSES_DEFINE = USE_NCURSES_H
endif

MKFONTDIR ?= $(shell which mkfontdir)

export CC
export CFLAGS
export CURSES_CFLAGS
export NPROCS
export MAKEFLAGS
export AR
export RANLIB
export SYSCONFDIR
export SDL_CFLAGS
export COLOR
export ITALIC
export SOUND_TYPE
export NO_SOUND

NAME = frotz
VERSION = 2.53
RELEASE_NOTES = "Official release."

# If we're working from git, we have access to proper variables. If
# not, make it clear that we're working from a release.
#
GIT_DIR ?= .git
ifneq ($(and $(wildcard $(GIT_DIR)),$(shell which git)),)
GIT_HASH = $(shell git rev-parse HEAD)
GIT_HASH_SHORT = $(shell git rev-parse --short HEAD)
GIT_DATE = $(shell git show -s --format=%ci)
else
GIT_HASH = 85a3a98dcbae0ee5aa036686a13b1088f7d6de17
GIT_HASH_SHORT = 85a3a98
GIT_DATE = 2021-02-27 16:50:16 -0800
endif
export CFLAGS


# Source locations
#
SRCDIR = src
COMMON_DIR = $(SRCDIR)/common
COMMON_LIB = $(COMMON_DIR)/frotz_common.a
COMMON_DEFINES = $(COMMON_DIR)/defs.h
HASH = $(COMMON_DIR)/git_hash.h

BLORB_DIR = $(SRCDIR)/blorb
BLORB_LIB = $(BLORB_DIR)/blorblib.a

CURSES_DIR = $(SRCDIR)/curses
CURSES_LIB = $(CURSES_DIR)/frotz_curses.a
CURSES_DEFINES = $(CURSES_DIR)/ux_defines.h

DUMB_DIR = $(SRCDIR)/dumb
DUMB_LIB = $(DUMB_DIR)/frotz_dumb.a

DOS_DIR = $(SRCDIR)/dos
DOS_DEFINES = $(DOS_DIR)/defs.h

OW_DOS_DIR = $(SRCDIR)/owdos
OW_DOS_DEFINES = $(OW_DOS_DIR)/defs.h

X11_DIR = $(SRCDIR)/x11
X11_LIB = $(X11_DIR)/frotz_x11.a
export X11_PKGS = x11 xt
X11_FONTDIR = $(DESTDIR)$(PREFIX)/share/fonts/X11/zork
X11_LDFLAGS = `pkg-config $(X11_PKGS) --libs` -lm

SDL_DIR = $(SRCDIR)/sdl
SDL_LIB = $(SDL_DIR)/frotz_sdl.a
export SDL_PKGS = libpng libjpeg sdl2 SDL2_mixer freetype2 zlib
SDL_LDFLAGS += $(shell $(PKG_CONFIG) $(SDL_PKGS) --libs) -lm

SUBDIRS = $(COMMON_DIR) $(CURSES_DIR) $(X11_DIR) $(SDL_DIR) $(DUMB_DIR) $(BLORB_DIR) $(DOS_DIR) $(OW_DOS_DIR)
SUB_CLEAN = $(SUBDIRS:%=%-clean)

FROTZ_BIN = frotz$(EXTENSION)
DFROTZ_BIN = dfrotz$(EXTENSION)
XFROTZ_BIN = xfrotz$(EXTENSION)
SFROTZ_BIN = sfrotz$(EXTENSION)
DOS_BIN = frotz.exe

FROTZ_LIBS  = $(COMMON_LIB) $(CURSES_LIB) $(BLORB_LIB) $(COMMON_LIB)
DFROTZ_LIBS = $(COMMON_LIB) $(DUMB_LIB) $(BLORB_LIB) $(COMMON_LIB)
XFROTZ_LIBS = $(COMMON_LIB) $(X11_LIB) $(BLORB_LIB) $(COMMON_LIB)
SFROTZ_LIBS = $(COMMON_LIB) $(SDL_LIB) $(BLORB_LIB) $(COMMON_LIB)


ifdef NO_BLORB
SOUND_TYPE = none
CURSES_SOUND = disabled
BLORB_SUPPORT = disabled
FROTZ_LIBS  = $(COMMON_LIB) $(CURSES_LIB) $(COMMON_LIB)
DFROTZ_LIBS = $(COMMON_LIB) $(DUMB_LIB) $(COMMON_LIB)
else
BLORB_SUPPORT = enabled
endif

ifeq ($(SOUND_TYPE), ao)
CURSES_SOUND_LDFLAGS += -lao -lpthread -lm \
			-lsndfile -lvorbisfile -lmodplug -lsamplerate
CURSES_SOUND = enabled
else
CURSES_SOUND = disabled
endif

# Check to see if the -Orecurse option is available.  It's nice for
# watching the output of a parallel build, but is otherwise not
# necessary.
ifneq ($(filter output-sync,$(value .FEATURES)),)
MAKEFLAGS += -Orecurse
endif

# Just the version number without the dot
DOSVER = $(shell echo $(VERSION) | sed s/\\.//g)

# Build recipes
#
curses: $(FROTZ_BIN)
ncurses: $(FROTZ_BIN)
$(FROTZ_BIN): $(FROTZ_LIBS)
	$(CC) $+ -o $@$(EXTENSION) $(LDFLAGS) $(CURSES_LDFLAGS) $(CURSES_SOUND_LDFLAGS)
	@echo "** Done building Frotz with curses interface"
	@echo "** Audio support $(CURSES_SOUND) (type $(SOUND_TYPE))"
	@echo "** Blorb support $(BLORB_SUPPORT)"

nosound: nosound_helper $(FROTZ_BIN) | nosound_helper
nosound_helper:
	$(eval SOUND_TYPE= none)
	$(eval NO_SOUND= -DNO_SOUND)
	$(eval CURSES_SOUND_LDFLAGS= )
	$(eval CURSES_SOUND= disabled)

dumb: $(DFROTZ_BIN)
$(DFROTZ_BIN): $(DFROTZ_LIBS)
	$(CC) $+ -o $@$(EXTENSION) $(LDFLAGS)
	@echo "** Done building Frotz with dumb interface."
	@echo "** Blorb support $(BLORB_SUPPORT)"

x11: $(XFROTZ_BIN)
$(XFROTZ_BIN): $(XFROTZ_LIBS)
	$(CC) $+ -o $@$(EXTENSION) $(LDFLAGS) $(X11_LDFLAGS)
	@echo "** Done building Frotz with X11 interface."

sdl: $(SFROTZ_BIN)
$(SFROTZ_BIN): $(SFROTZ_LIBS)
	$(CC) $+ -o $@$(EXTENSION) $(LDFLAGS) $(SDL_LDFLAGS)
	@echo "** Done building Frotz with SDL interface."

dos: $(DOS_BIN)
$(DOS_BIN): $(DOS_DEFINES) $(OW_DOS_DEFINES) $(HASH)
ifneq ($(and $(wildcard $(GIT_DIR)),$(shell which git)),)
	@echo
	@echo "  ** Cannot cross-compile for DOS yet."
	@echo "  ** Copy this zip file, $(NAME)src.zip, into a DOS machine and use Turbo C."
	@echo "  ** or Open Watcom C.  A virtualized DOS machine will do.  This zip file"
	@echo "  ** will fit on a single double-sided double-density 5.25-inch floppy disk."
	@echo "  ** Read the file INSTALL_DOS for more information."
	@echo
	@git archive --format=zip --prefix $(NAME)src/ HEAD -o $(NAME)src.zip
	@zip -d $(NAME)src.zip $(NAME)src/src/curses/* \
		$(NAME)src/src/dumb/* $(NAME)src/src/blorb/* \
		$(NAME)src/src/sdl/* $(NAME)src/src/misc/* \
		$(NAME)src/src/x11/* \
		$(NAME)src/doc/*.6 $(NAME)src/doc/frotz.conf* \
		$(NAME)src/doc/Xresources  > /dev/null
	@mkdir -p $(NAME)src/$(DOS_DIR) $(NAME)src/$(OW_DOS_DIR)
	@cp $(DOS_DEFINES) $(NAME)src/$(DOS_DIR)
	@cp $(OW_DOS_DEFINES) $(NAME)src/$(OW_DOS_DIR)
	@zip $(NAME)src.zip $(NAME)src/$(DOS_DEFINES) $(NAME)src/$(OW_DOS_DEFINES) > /dev/null
	@rm -rf $(NAME)src

else
	@echo "Not in a git repository or git command not found.  Cannot make a tarball."
endif

all: $(FROTZ_BIN) $(DFROTZ_BIN) $(SFROTZ_BIN) $(XFROTZ_BIN)

common_lib:	$(COMMON_LIB)
curses_lib:	$(CURSES_LIB)
x11_lib:	$(X11_LIB)
sdl_lib:	$(SDL_LIB)
dumb_lib:	$(DUMB_LIB)
blorb_lib:	$(BLORB_LIB)
dos_lib:	$(DOS_LIB)

$(COMMON_LIB): $(COMMON_DEFINES) $(HASH)
	$(MAKE) -C $(COMMON_DIR)

$(CURSES_LIB): $(COMMON_DEFINES) $(CURSES_DEFINES) $(HASH)
	$(MAKE) -C $(CURSES_DIR)

$(X11_LIB): $(COMMON_DEFINES) $(HASH)
	$(MAKE) -C $(X11_DIR)

$(SDL_LIB): $(COMMON_DEFINES) $(HASH) $(SDL_DIR)

=== src/blorb/Makefile ===
# Makefile for Unix Frotz
# GNU make is required

SOURCES = blorblib.c

HEADERS = blorb.h blorblow.h

OBJECTS = $(SOURCES:.c=.o)

TARGET = blorblib.a

ARFLAGS = rc

.PHONY: clean
.DELETE_ON_ERROR:

$(TARGET): $(OBJECTS)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@
	@echo "** Done with Blorb library."

clean:
	rm -f $(TARGET) $(OBJECTS)

%.o: %.c
	$(CC) $(CFLAGS) -fPIC -fpic -o $@ -c $<

=== src/common/Makefile ===
# Makefile for Unix Frotz
# GNU make is required.

SOURCES = buffer.c err.c fastmem.c files.c getopt.c hotkey.c input.c \
	main.c math.c missing.c object.c process.c quetzal.c random.c \
	redirect.c screen.c sound.c stream.c table.c text.c variable.c

HEADERS = frotz.h setup.h unused.h

OBJECTS = $(SOURCES:.c=.o)

TARGET = frotz_common.a

ARFLAGS = rc

.PHONY: clean
.DELETE_ON_ERROR:

$(TARGET): $(OBJECTS)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@
	@echo "** Done with Frotz core."

clean:
	rm -f $(TARGET) $(OBJECTS)
	rm -f *.O DEFS.H

%.o: %.c
	$(CC) $(CFLAGS) -fPIC -fpic -o $@ -c $<

=== src/curses/Makefile ===
# Makefile for Unix Frotz
# GNU make is required.

SOURCES = ux_audio.c ux_audio_none.c ux_audio_oss.c ux_blorb.c ux_init.c \
	ux_input.c ux_pic.c ux_screen.c ux_text.c

HEADERS = ux_blorb.h ux_frotz.h ux_setup.h defines.h

OBJECTS = $(SOURCES:.c=.o)

TARGET = frotz_curses.a

ARFLAGS = rc

SOUND_TYPE ?= ao

ifeq ($(SOUND_TYPE), ao)
ifneq ($(UNAME_S),Haiku)
CFLAGS += -pthread
endif
else ifeq ($(SOUND_TYPE), none)

else ifndef SOUND_TYPE

else
$(error Invalid sound choice $(SOUND_TYPE))
endif

.PHONY: clean
.DELETE_ON_ERROR:

$(TARGET): $(OBJECTS)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@
	@echo "** Done with curses interface."

clean:
	rm -f $(TARGET) $(OBJECTS)

%.o: %.c
	$(CC) $(CFLAGS) $(CURSES_CFLAGS) $(NO_SOUND) -fPIC -fpic -o $@ -c $<

=== src/dos/Makefile ===
# For GNU Make.

SOURCES = bcblorb.c bcinit.c bcinput.c bcmouse.c bcpic.c bcsample.c bcscreen bctext.c

HEADERS = bcfrotz.h blorb.h blorblow.h fontdata.h

OBJECTS = $(SOURCES:.c=.o)

.PHONY: clean

$(TARGET): $(OBJECTS)
	@echo "** Done with DOS interface."

clean:
	rm -f $(TARGET) $(OBJECTS)
	rm -f *.O

%.o: %.c
	$(WCC) $(CFLAGS) $(DOS_CFLAGS) -o $@ -c $<

=== src/dumb/Makefile ===
# Makefile for Unix Frotz
# GNU make is required

SOURCES = dblorb.c dinit.c dinput.c doutput.c dpic.c

OBJECTS = $(SOURCES:.c=.o)

TARGET = frotz_dumb.a

ARFLAGS = rc

.PHONY: clean
.DELETE_ON_ERROR:

$(TARGET): $(OBJECTS)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@
	@echo "** Done with dumb interface."

clean:
	rm -f $(TARGET) $(OBJECTS)

%.o: %.c
	$(CC) $(CFLAGS) -fPIC -fpic -o $@ -c $<

=== src/owdos/Makefile ===
# For GNU Make.

SOURCES = owblorb.c owinit.c owinput.c owmouse.c owpic.c owsample.c owscreen.c owtext.c
HEADERS = blorb.h blorblow.h fontdata.h owblorb.h owfrotz.h owhash.h
OBJECTS = $(SOURCES:.c=.o)

%.o: %.c
	$(WCC) $(CFLAGS) $(DOS_CFLAGS) -o $@ -c $<

.PHONY:	clean

clean:
	rm -f $(TARGET) $(OBJECTS)
	rm -f *.O

=== src/sdl/Makefile ===
# Makefile for Unix Frotz
# GNU make is required

SDL_PKGS ?= libpng libjpeg sdl2 SDL2_mixer freetype2 zlib

# Dependency generation requires GCC or clang.
CC = gcc
#CC = clang

PKG_CONFIG ?= pkg-config

SOURCES = sf_fonts.c sf_msg_en.c sf_resource.c sf_util.c \
	sf_deffont.c sf_ftype.c sf_osfdlg.c sf_sig.c sf_video.c \
	sf_font3.c sf_images.c sf_sound.c generic.c

HEADERS = sf_frotz.h

OBJECTS = $(SOURCES:.c=.o)

DEPS = $(SOURCES:.c=.d)

TARGET = frotz_sdl.a

ARFLAGS = rc

.PHONY: clean
.DELETE_ON_ERROR:

$(TARGET): $(OBJECTS)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@
	@echo "** Done with SDL interface."

clean:
	-rm -f $(TARGET) $(OBJECTS) $(DEPS)

%.o: override CFLAGS += $(shell $(PKG_CONFIG) $(SDL_PKGS) --cflags) $(SDL_CFLAGS)

%.o: %.c
	$(CC) $(CFLAGS) -fPIC -fpic -o $@ -c $<

=== src/x11/Makefile ===
# For GNU Make.

SOURCES = x_init.c x_input.c x_pic.c x_sample.c x_screen.c x_text.c x_blorb.c
OBJECTS = $(SOURCES:.c=.o)
HEADERS = x_frotz.h x_setup.h x_blorb.h

ZFONTSBDF = Zork_r400-10.bdf Zork_r400-11.bdf Zork_r400-13.bdf Zork_r400-16.bdf Zork_r400-20.bdf
ZFONTSPCF = $(ZFONTSBDF:.bdf=.pcf)

TARGET = frotz_x11.a

ARFLAGS = rc

SOUND ?= ao

CFLAGS += -DNO_SOUND

.PHONY: clean
.SUFFIXES: .bdf .c .o .pcf
.DELETE_ON_ERROR:

$(TARGET): $(OBJECTS) $(ZFONTSPCF)
	$(AR) $(ARFLAGS) $(TARGET) $(OBJECTS) $?
	$(RANLIB) $@
	@echo "** Done with X11 interface."

clean:
	rm -f $(TARGET) $(OBJECTS) $(ZFONTSPCF)

%.o: %.c
	$(CC) $(CFLAGS) -fPIC -fpic -o $@ -c $<

.bdf.pcf:
	bdftopcf -t $< -o $@

=== debian/changelog ===
frotz (2.53+dfsg-1) unstable; urgency=medium

  * New upstream bug-fix release.
  * Acknowledge old NMUs. Closes: #812505, #966128.
  * Standards-Version 4.5.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Tue, 02 Mar 2021 14:09:25 +0100

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libsndfile1-dev,
  libvorbis-dev,
  zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/games-team/frotz
 Vcs-Git: https://salsa.debian.org/games-team/frotz.git
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- CFLAGS="$(CPPFLAGS) $(CFLAGS)" all
+	dh_auto_build -- BINDIR=/usr/games CFLAGS="$(CPPFLAGS) $(CFLAGS)" curses dumb sdl
 
 override_dh_auto_install:
-	$(MAKE) PREFIX=$$(pwd)/debian/tmp/usr install_all
+	dh_auto_install -- BINDIR=/usr/games PREFIX=/usr install_frotz install_dfrotz install_sfrotz

## frotz 2.54%2Bdfsg

=== debian/watch ===
version=4
opts="dversionmangle=auto,repacksuffix=+dfsg" \
  https://gitlab.com/DavidGriffith/frotz/tags?sort=updated_desc \
  archive/@ANY_VERSION@/frotz-\d\S*@ARCHIVE_EXT@
